// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mavros_msgs:srv/CommandInt.idl
// generated code does not contain a copyright notice

#ifndef MAVROS_MSGS__SRV__DETAIL__COMMAND_INT__TRAITS_HPP_
#define MAVROS_MSGS__SRV__DETAIL__COMMAND_INT__TRAITS_HPP_

#include "mavros_msgs/srv/detail/command_int__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::srv::CommandInt_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: broadcast
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "broadcast: ";
    value_to_yaml(msg.broadcast, out);
    out << "\n";
  }

  // member: frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "frame: ";
    value_to_yaml(msg.frame, out);
    out << "\n";
  }

  // member: command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command: ";
    value_to_yaml(msg.command, out);
    out << "\n";
  }

  // member: current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "current: ";
    value_to_yaml(msg.current, out);
    out << "\n";
  }

  // member: autocontinue
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "autocontinue: ";
    value_to_yaml(msg.autocontinue, out);
    out << "\n";
  }

  // member: param1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param1: ";
    value_to_yaml(msg.param1, out);
    out << "\n";
  }

  // member: param2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param2: ";
    value_to_yaml(msg.param2, out);
    out << "\n";
  }

  // member: param3
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param3: ";
    value_to_yaml(msg.param3, out);
    out << "\n";
  }

  // member: param4
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param4: ";
    value_to_yaml(msg.param4, out);
    out << "\n";
  }

  // member: x
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "x: ";
    value_to_yaml(msg.x, out);
    out << "\n";
  }

  // member: y
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "y: ";
    value_to_yaml(msg.y, out);
    out << "\n";
  }

  // member: z
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "z: ";
    value_to_yaml(msg.z, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::srv::CommandInt_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::srv::CommandInt_Request>()
{
  return "mavros_msgs::srv::CommandInt_Request";
}

template<>
inline const char * name<mavros_msgs::srv::CommandInt_Request>()
{
  return "mavros_msgs/srv/CommandInt_Request";
}

template<>
struct has_fixed_size<mavros_msgs::srv::CommandInt_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<mavros_msgs::srv::CommandInt_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<mavros_msgs::srv::CommandInt_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::srv::CommandInt_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::srv::CommandInt_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::srv::CommandInt_Response>()
{
  return "mavros_msgs::srv::CommandInt_Response";
}

template<>
inline const char * name<mavros_msgs::srv::CommandInt_Response>()
{
  return "mavros_msgs/srv/CommandInt_Response";
}

template<>
struct has_fixed_size<mavros_msgs::srv::CommandInt_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<mavros_msgs::srv::CommandInt_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<mavros_msgs::srv::CommandInt_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<mavros_msgs::srv::CommandInt>()
{
  return "mavros_msgs::srv::CommandInt";
}

template<>
inline const char * name<mavros_msgs::srv::CommandInt>()
{
  return "mavros_msgs/srv/CommandInt";
}

template<>
struct has_fixed_size<mavros_msgs::srv::CommandInt>
  : std::integral_constant<
    bool,
    has_fixed_size<mavros_msgs::srv::CommandInt_Request>::value &&
    has_fixed_size<mavros_msgs::srv::CommandInt_Response>::value
  >
{
};

template<>
struct has_bounded_size<mavros_msgs::srv::CommandInt>
  : std::integral_constant<
    bool,
    has_bounded_size<mavros_msgs::srv::CommandInt_Request>::value &&
    has_bounded_size<mavros_msgs::srv::CommandInt_Response>::value
  >
{
};

template<>
struct is_service<mavros_msgs::srv::CommandInt>
  : std::true_type
{
};

template<>
struct is_service_request<mavros_msgs::srv::CommandInt_Request>
  : std::true_type
{
};

template<>
struct is_service_response<mavros_msgs::srv::CommandInt_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MAVROS_MSGS__SRV__DETAIL__COMMAND_INT__TRAITS_HPP_
