// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mavros_msgs:srv/CommandLong.idl
// generated code does not contain a copyright notice

#ifndef MAVROS_MSGS__SRV__DETAIL__COMMAND_LONG__TRAITS_HPP_
#define MAVROS_MSGS__SRV__DETAIL__COMMAND_LONG__TRAITS_HPP_

#include "mavros_msgs/srv/detail/command_long__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::srv::CommandLong_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: broadcast
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "broadcast: ";
    value_to_yaml(msg.broadcast, out);
    out << "\n";
  }

  // member: command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command: ";
    value_to_yaml(msg.command, out);
    out << "\n";
  }

  // member: confirmation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confirmation: ";
    value_to_yaml(msg.confirmation, out);
    out << "\n";
  }

  // member: param1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param1: ";
    value_to_yaml(msg.param1, out);
    out << "\n";
  }

  // member: param2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param2: ";
    value_to_yaml(msg.param2, out);
    out << "\n";
  }

  // member: param3
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param3: ";
    value_to_yaml(msg.param3, out);
    out << "\n";
  }

  // member: param4
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param4: ";
    value_to_yaml(msg.param4, out);
    out << "\n";
  }

  // member: param5
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param5: ";
    value_to_yaml(msg.param5, out);
    out << "\n";
  }

  // member: param6
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param6: ";
    value_to_yaml(msg.param6, out);
    out << "\n";
  }

  // member: param7
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "param7: ";
    value_to_yaml(msg.param7, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::srv::CommandLong_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::srv::CommandLong_Request>()
{
  return "mavros_msgs::srv::CommandLong_Request";
}

template<>
inline const char * name<mavros_msgs::srv::CommandLong_Request>()
{
  return "mavros_msgs/srv/CommandLong_Request";
}

template<>
struct has_fixed_size<mavros_msgs::srv::CommandLong_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<mavros_msgs::srv::CommandLong_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<mavros_msgs::srv::CommandLong_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::srv::CommandLong_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result: ";
    value_to_yaml(msg.result, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::srv::CommandLong_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::srv::CommandLong_Response>()
{
  return "mavros_msgs::srv::CommandLong_Response";
}

template<>
inline const char * name<mavros_msgs::srv::CommandLong_Response>()
{
  return "mavros_msgs/srv/CommandLong_Response";
}

template<>
struct has_fixed_size<mavros_msgs::srv::CommandLong_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<mavros_msgs::srv::CommandLong_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<mavros_msgs::srv::CommandLong_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<mavros_msgs::srv::CommandLong>()
{
  return "mavros_msgs::srv::CommandLong";
}

template<>
inline const char * name<mavros_msgs::srv::CommandLong>()
{
  return "mavros_msgs/srv/CommandLong";
}

template<>
struct has_fixed_size<mavros_msgs::srv::CommandLong>
  : std::integral_constant<
    bool,
    has_fixed_size<mavros_msgs::srv::CommandLong_Request>::value &&
    has_fixed_size<mavros_msgs::srv::CommandLong_Response>::value
  >
{
};

template<>
struct has_bounded_size<mavros_msgs::srv::CommandLong>
  : std::integral_constant<
    bool,
    has_bounded_size<mavros_msgs::srv::CommandLong_Request>::value &&
    has_bounded_size<mavros_msgs::srv::CommandLong_Response>::value
  >
{
};

template<>
struct is_service<mavros_msgs::srv::CommandLong>
  : std::true_type
{
};

template<>
struct is_service_request<mavros_msgs::srv::CommandLong_Request>
  : std::true_type
{
};

template<>
struct is_service_response<mavros_msgs::srv::CommandLong_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MAVROS_MSGS__SRV__DETAIL__COMMAND_LONG__TRAITS_HPP_
