// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mavros_msgs:msg/CameraImageCaptured.idl
// generated code does not contain a copyright notice

#ifndef MAVROS_MSGS__MSG__DETAIL__CAMERA_IMAGE_CAPTURED__TRAITS_HPP_
#define MAVROS_MSGS__MSG__DETAIL__CAMERA_IMAGE_CAPTURED__TRAITS_HPP_

#include "mavros_msgs/msg/detail/camera_image_captured__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'orientation'
#include "geometry_msgs/msg/detail/quaternion__traits.hpp"
// Member 'geo'
#include "geographic_msgs/msg/detail/geo_point__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::msg::CameraImageCaptured & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation:\n";
    to_yaml(msg.orientation, out, indentation + 2);
  }

  // member: geo
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "geo:\n";
    to_yaml(msg.geo, out, indentation + 2);
  }

  // member: relative_alt
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "relative_alt: ";
    value_to_yaml(msg.relative_alt, out);
    out << "\n";
  }

  // member: image_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "image_index: ";
    value_to_yaml(msg.image_index, out);
    out << "\n";
  }

  // member: capture_result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "capture_result: ";
    value_to_yaml(msg.capture_result, out);
    out << "\n";
  }

  // member: file_url
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "file_url: ";
    value_to_yaml(msg.file_url, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::msg::CameraImageCaptured & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::msg::CameraImageCaptured>()
{
  return "mavros_msgs::msg::CameraImageCaptured";
}

template<>
inline const char * name<mavros_msgs::msg::CameraImageCaptured>()
{
  return "mavros_msgs/msg/CameraImageCaptured";
}

template<>
struct has_fixed_size<mavros_msgs::msg::CameraImageCaptured>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mavros_msgs::msg::CameraImageCaptured>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<mavros_msgs::msg::CameraImageCaptured>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MAVROS_MSGS__MSG__DETAIL__CAMERA_IMAGE_CAPTURED__TRAITS_HPP_
