// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mavros_msgs:msg/DebugValue.idl
// generated code does not contain a copyright notice

#ifndef MAVROS_MSGS__MSG__DETAIL__DEBUG_VALUE__TRAITS_HPP_
#define MAVROS_MSGS__MSG__DETAIL__DEBUG_VALUE__TRAITS_HPP_

#include "mavros_msgs/msg/detail/debug_value__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::msg::DebugValue & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "index: ";
    value_to_yaml(msg.index, out);
    out << "\n";
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: value_float
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value_float: ";
    value_to_yaml(msg.value_float, out);
    out << "\n";
  }

  // member: value_int
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "value_int: ";
    value_to_yaml(msg.value_int, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    value_to_yaml(msg.type, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::msg::DebugValue & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::msg::DebugValue>()
{
  return "mavros_msgs::msg::DebugValue";
}

template<>
inline const char * name<mavros_msgs::msg::DebugValue>()
{
  return "mavros_msgs/msg/DebugValue";
}

template<>
struct has_fixed_size<mavros_msgs::msg::DebugValue>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mavros_msgs::msg::DebugValue>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<mavros_msgs::msg::DebugValue>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MAVROS_MSGS__MSG__DETAIL__DEBUG_VALUE__TRAITS_HPP_
