// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mavros_msgs:msg/Mavlink.idl
// generated code does not contain a copyright notice

#ifndef MAVROS_MSGS__MSG__DETAIL__MAVLINK__TRAITS_HPP_
#define MAVROS_MSGS__MSG__DETAIL__MAVLINK__TRAITS_HPP_

#include "mavros_msgs/msg/detail/mavlink__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const mavros_msgs::msg::Mavlink & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: framing_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "framing_status: ";
    value_to_yaml(msg.framing_status, out);
    out << "\n";
  }

  // member: magic
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "magic: ";
    value_to_yaml(msg.magic, out);
    out << "\n";
  }

  // member: len
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "len: ";
    value_to_yaml(msg.len, out);
    out << "\n";
  }

  // member: incompat_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "incompat_flags: ";
    value_to_yaml(msg.incompat_flags, out);
    out << "\n";
  }

  // member: compat_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "compat_flags: ";
    value_to_yaml(msg.compat_flags, out);
    out << "\n";
  }

  // member: seq
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seq: ";
    value_to_yaml(msg.seq, out);
    out << "\n";
  }

  // member: sysid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sysid: ";
    value_to_yaml(msg.sysid, out);
    out << "\n";
  }

  // member: compid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "compid: ";
    value_to_yaml(msg.compid, out);
    out << "\n";
  }

  // member: msgid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "msgid: ";
    value_to_yaml(msg.msgid, out);
    out << "\n";
  }

  // member: checksum
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "checksum: ";
    value_to_yaml(msg.checksum, out);
    out << "\n";
  }

  // member: payload64
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.payload64.size() == 0) {
      out << "payload64: []\n";
    } else {
      out << "payload64:\n";
      for (auto item : msg.payload64) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: signature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.signature.size() == 0) {
      out << "signature: []\n";
    } else {
      out << "signature:\n";
      for (auto item : msg.signature) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const mavros_msgs::msg::Mavlink & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<mavros_msgs::msg::Mavlink>()
{
  return "mavros_msgs::msg::Mavlink";
}

template<>
inline const char * name<mavros_msgs::msg::Mavlink>()
{
  return "mavros_msgs/msg/Mavlink";
}

template<>
struct has_fixed_size<mavros_msgs::msg::Mavlink>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<mavros_msgs::msg::Mavlink>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<mavros_msgs::msg::Mavlink>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MAVROS_MSGS__MSG__DETAIL__MAVLINK__TRAITS_HPP_
